// controllers/user.js

const mysql = require('mysql');
var con = require('../connection.js');
const UserDetails = require('../models/userDetails.js');
const twilio = require('twilio');

con.connect(function(err) {
  if (err) throw err;
  console.log("Connected!");
});

const updateHitCountAsync = async (req, res) => {

    const { mobileNumber, apiKey } = req.body;

    const updateQuery = `
      UPDATE UserDetails
      SET hitCount = hitCount + 1
      WHERE mobileNumber = ${mobileNumber} AND apiKey = '${apiKey}'
    `;

    const result = await new Promise((resolve, reject) => {
      con.query(updateQuery, (error, result) => {
        if (error) {
          reject(error);
        } else {
          resolve(result);
        }
      });
    });

//     if (result.affectedRows > 0) { 
//       const response = { success: true, message: 'hitCount updated successfully' };
//       res.json(response);
//     } else {
//       const response = { success: false, message: 'No matching record found' };
//       res.status(404).json(response);
//     }
};




// Promisify the get_user function to be able to use async/await
const getUserAsync = (imeiNumber) => {
  return new Promise((resolve, reject) => {
    //const imeiNumber = req.query.imei;
    console.log('IMEI Numberssss:', imeiNumber);

    const query = `SELECT mobileNumber FROM UserDetails WHERE
    CONCAT(',', imeiNumber) LIKE CONCAT('%,', '${imeiNumber}', '%') OR
    CONCAT(',', imeiNumber, ',') LIKE CONCAT('%', '${imeiNumber}', ',%')`

    con.query(query, (error, result) => {
      if (error) {
        console.log('Error:', error);
        reject(error);
      } else {
        resolve(result);
      }
    });
  });
};

// Create a new function to call getUserAsync and handle the response
const get_user = async (req, res) => {
  try {
    const {imeiNumber} = req.body;
    console.log('IMEI Numberssssqqq:', imeiNumber);
    const result = await getUserAsync(imeiNumber);
    await updateHitCountAsync(req, res);

    if (result.length > 0) {
      const data = {
        message: 'IMEI number exists in the database',
        mobileNumbers: result
      };
      res.json(data);
    } else {
      const data = { message: 'IMEI number does not exist in the database' };
      res.json(data);
    }
  } catch (error) {
    console.log('Error:', error);
    const data = { message: 'An error occurred' };
    res.status(500).json(data);
  }
};

// Now you can call getUserAndResponse from any other function or route to get the response

function generateOTP() {
  const digits = '0123456789';
  let otp = '';

  for (let i = 0; i < 4; i++) {
    const randomIndex = Math.floor(Math.random() * digits.length);
    otp += digits[randomIndex];
  }

  return otp;
}

// Temporary storage for generated OTPs
const otpStorage = {};

const sendOTP = async (req, res) => {
  
  const { mobileNumber } = req.body;
  console.log('mobileNumber:', mobileNumber);
  try {
    const accountSid = 'AC0135f3e89949c1869226cd7b7a08114b';
    const authToken = '886fc38d206a052995fbce069c96be09';
    const client = twilio(accountSid, authToken);

    const generatedOTP = generateOTP();
    otpStorage[mobileNumber] = generatedOTP; // Store OTP temporarily
    await client.messages.create({
      body: `Your OTP is: ${generatedOTP}`,
      to: `+91${mobileNumber}`, // The user's phone number with country code
      from: '+14066428086', // Your Twilio phone number
    });

    console.log('OTP sent successfully:', generatedOTP);
    const response = { mobileNumber, success: true, message: 'OTP Sent' };
    res.json(response);
    return;
  } catch (error) {
        console.log('Error sending OTP:', error);
        const response = { mobileNumber, success: false, message: 'Incorrect OTP' };
        res.json(response);
        return;
  }
};

const otp_verify = async (req, res) => {
  const { otpNumber, mobileNumber, imeiNumber } = req.body;
  console.log('OTP:', otpNumber);
  console.log('mobileNumber:', mobileNumber);

  // Verify the entered OTP with the stored OTP
  const storedOTP = otpStorage[mobileNumber];

  if (!storedOTP || otpNumber !== storedOTP) {
    const response = { mobileNumber, success: false, message: 'Incorrect OTP' };
    res.json(response);
    return;
  }
  
  // OTP is correct, call post_login function here or perform any other actions you need to do
   const result = await getUserAsync(imeiNumber);
    console.log('result', result);
    if (result.length === 0) {
        post_add_user(req, res);
       
    }
    else {
            const response = { mobileNumber, success: false, message: 'Mobile Number and IMEI Number both exists' };
            res.json(response);
            return;
    }
};

const post_add_user = async (req, res) => {
  const { imeiNumber, mobileNumber, apiKey } = req.body;
  console.log('IMEI Numbers:', imeiNumber);
  console.log('Mobile Number:', mobileNumber);
  console.log('API Key:', apiKey);
  await updateHitCountAsync(req, res);
  try {
    const checkImeiExistQuery = `SELECT COUNT(*) AS count FROM UserDetails WHERE imeiNumber = '${imeiNumber}'`;
    con.query(checkImeiExistQuery, (error, result) => {
      if (error) {
        console.log('Error:', error);
        const response = { mobileNumber: null, success: false };
        res.json(response);
      } else {
        const imeiExists = result[0].count > 0;

        if (!imeiExists) {
          const checkMobileQuery = `SELECT COUNT(*) AS count FROM UserDetails WHERE mobileNumber = ${mobileNumber}`;
          con.query(checkMobileQuery, (error, result) => {
            if (error) {
              console.log('Error:', error);
              const response = { mobileNumber: null, success: false };
              res.json(response);
            } else {
              const mobileExists = result[0].count > 0;

              if (!mobileExists) {
                const insertQuery = `INSERT INTO UserDetails (mobileNumber, imeiNumber, apiKey) VALUES (${mobileNumber}, '${imeiNumber + ', '}', '${apiKey}')`;
                con.query(insertQuery, (error) => {
                  if (error) {
                    console.log('Error:', error);
                    const response = { mobileNumber: null, success: false };
                    res.json(response);
                  } else {
                    const response = { mobileNumber, success: true };
                    res.json(response);
                  }
                });
              } else {
                const updateQuery = `UPDATE UserDetails SET imeiNumber = CONCAT(imeiNumber, '${imeiNumber + ', '}') WHERE mobileNumber = ${mobileNumber}`;
                con.query(updateQuery, (error) => {
                  if (error) {
                    console.log('Error:', error);
                    const response = { mobileNumber: null, success: false };
                    res.json(response);
                  } else {
                    const response = { mobileNumber, success: true };
                    res.json(response);
                  }
                });
              }
            }
          });
        } 
      }
    });
  } catch (error) {
    console.log('Error:', error);
    const response = { mobileNumber: null, success: false };
    res.json(response);
  }
};

module.exports = { get_user, otp_verify, sendOTP };

